# Rekurze na seznamech.

empty = []

def cons(val, lst):
    return [val, lst]

def first(lst):
    return lst[0]

def rest(lst):
    return lst[1]

def is_empty(lst):
    return lst == empty

# Testovací seznam:
l1 = cons(1, cons(2, cons(3, empty)))

# Délka seznamu.
def length(lst):
    return (0
            if is_empty(lst)
            else 1 + length(rest(lst)))
"""
>>> length(empty)
0
>>> length(l1)
3
>>> length(rest(l1))
2
"""

# Test příslušnosti prvku do seznamu.
def is_member(val, lst):
    return (not is_empty(lst)
            and (first(lst) == val
                 or is_member(val, rest(lst))))

"""
>>> is_member(1, empty)
False
>>> is_member(1, l1)
True
>>> is_member(3, l1)
True
>>> is_member(4, l1)
False
"""




